<!DOCTYPE html>
<html lang="en">
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0"/>
    <meta charset="utf-8"/>
    <title>API Documentation &raquo;\PhpOffice\PhpSpreadsheet\Shared\JAMA\LUDecomposition</title>
    <meta name="author" content=""/>
    <meta name="description" content=""/>        <link href="../css/template.css" rel="stylesheet" media="all"/>        <!--[if lt IE 9]>
        <script src="https://html5shim.googlecode.com/svn/trunk/html5.js" type="text/javascript"></script>
        <![endif]-->
        <script src="../js/jquery-1.7.1.min.js" type="text/javascript"></script>
        <script src="../js/jquery-ui-1.8.2.custom.min.js" type="text/javascript"></script>
        <script src="../js/jquery.mousewheel.min.js" type="text/javascript"></script>
        <script src="../js/bootstrap.js" type="text/javascript"></script>
        <script src="../js/template.js" type="text/javascript"></script>
        <script src="../js/prettify/prettify.min.js" type="text/javascript"></script>        <link rel="shortcut icon" href="../img/favicon.ico"/>
        <link rel="apple-touch-icon" href="../img/apple-touch-icon.png"/>
        <link rel="apple-touch-icon" sizes="72x72" href="../img/apple-touch-icon-72x72.png"/>
        <link rel="apple-touch-icon" sizes="114x114" href="../img/apple-touch-icon-114x114.png"/></head>
<body>    <div class="navbar navbar-fixed-top">
        <div class="navbar-inner">
            <div class="container">
                <a class="btn btn-navbar" data-toggle="collapse" data-target=".nav-collapse">
                    <span class="icon-bar"></span> <span class="icon-bar"></span>
                    <span class="icon-bar"></span> </a>
                <a class="brand" href="../index.html">API Documentation</a>

                <div class="nav-collapse">
                    <ul class="nav">
                        <li class="dropdown">
                            <a href="#api" class="dropdown-toggle" data-toggle="dropdown">
                                API Documentation <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">                                    <li><a>Namespaces</a></li>                                    <li><a href="../namespaces/task_23.html">task_23</a></li>                                    <li><a href="../namespaces/task_18.html">task_18</a></li>                                    <li><a href="../namespaces/task_22.html">task_22</a></li>                                    <li><a href="../namespaces/Composer.html">Composer</a></li>                                    <li><a href="../namespaces/Matrix.html">Matrix</a></li>                                    <li><a href="../namespaces/Complex.html">Complex</a></li>                                    <li><a href="../namespaces/Psr.html">Psr</a></li>                                    <li><a href="../namespaces/PhpOffice.html">PhpOffice</a></li>                                    <li><a href="../namespaces/Samples.html">Samples</a></li>                                    <li><a href="../namespaces/task_21.html">task_21</a></li>                                    <li><a href="../namespaces/task_24.html">task_24</a></li>                                    <li><a href="../namespaces/task_20.html">task_20</a></li>                                    <li><a href="../namespaces/task_17.html">task_17</a></li>                                    <li><a href="../namespaces/task_19.html">task_19</a></li>                            </ul>
                        </li>
                        <li class="dropdown" id="charts-menu">
                            <a href="#charts" class="dropdown-toggle" data-toggle="dropdown">
                                Charts <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../graph_class.html">
                                        <i class="icon-list-alt"></i>&#160;Class hierarchy diagram
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="dropdown" id="reports-menu">
                            <a href="#reports" class="dropdown-toggle" data-toggle="dropdown">
                                Reports <b class="caret"></b>
                            </a>
                            <ul class="dropdown-menu">
                                <li>
                                    <a href="../errors.html">
                                        <i class="icon-list-alt"></i>&#160;Errors
                                    </a>
                                </li>
                                <li>
                                    <a href="../markers.html">
                                        <i class="icon-list-alt"></i>&#160;Markers
                                    </a>
                                </li>
                                <li>
                                    <a href="../deprecated.html">
                                        <i class="icon-list-alt"></i>&#160;Deprecated
                                    </a>
                                </li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="go_to_top">
            <a href="#___" style="color: inherit">Back to top&#160;&#160;<i class="icon-upload icon-white"></i></a>
        </div>
    </div>
    <div id="___" class="container">
        <noscript>
            <div class="alert alert-warning">
                Javascript is disabled; several features are only available if Javascript is enabled.
            </div>
        </noscript>    <style>
        .deprecated h2 {
            text-decoration: line-through;
        }
    </style>
    <div class="row">
        <div class="span4">    <div class="btn-group view pull-right" data-toggle="buttons-radio">
        <button class="btn details" title="Show descriptions and method names"><i class="icon-list"></i></button>
        <button class="btn simple" title="Show only method names"><i class="icon-align-justify"></i></button>
    </div>
    <div class="btn-group visibility" data-toggle="buttons-checkbox">
        <button class="btn public active" title="Show public elements">Public</button>
        <button class="btn protected" title="Show protected elements">Protected</button>
        <button class="btn private" title="Show private elements">Private</button>
        <button class="btn inherited active" title="Show inherited elements">Inherited</button>
    </div>    <ul class="side-nav nav nav-list">
        <li class="nav-header">
            <i class="icon-custom icon-method"></i> Methods
            <ul>    <li class="methodpublic">
        <a href="#method___construct" title="__construct ::LU Decomposition constructor.">
            <span class="description">LU Decomposition constructor.</span><pre>__construct</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_det" title="det ::Count determinants.">
            <span class="description">Count determinants.</span><pre>det</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getDoublePivot" title="getDoublePivot ::Alias for getPivot.">
            <span class="description">Alias for getPivot.</span><pre>getDoublePivot</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getL" title="getL ::Get lower triangular factor.">
            <span class="description">Get lower triangular factor.</span><pre>getL</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getPivot" title="getPivot ::Return pivot permutation vector.">
            <span class="description">Return pivot permutation vector.</span><pre>getPivot</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_getU" title="getU ::Get upper triangular factor.">
            <span class="description">Get upper triangular factor.</span><pre>getU</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_isNonsingular" title="isNonsingular ::Is the matrix nonsingular?">
            <span class="description">Is the matrix nonsingular?</span><pre>isNonsingular</pre>
        </a>
    </li>    <li class="methodpublic">
        <a href="#method_solve" title="solve ::Solve A*X = B.">
            <span class="description">Solve A*X = B.</span><pre>solve</pre>
        </a>
    </li>            </ul>
        </li>
        <li class="nav-header protected">» Protected
            <ul>            </ul>
        </li>
        <li class="nav-header private">» Private
            <ul>            </ul>
        </li>
        <li class="nav-header">
            <i class="icon-custom icon-constant"></i> Constants
            <ul>                <li class="constant">
                    <a href="#constant_MATRIX_SINGULAR_EXCEPTION" title="MATRIX_SINGULAR_EXCEPTION ::">
                        <span class="description"></span><pre>MATRIX_SINGULAR_EXCEPTION</pre>
                    </a>
                </li>                <li class="constant">
                    <a href="#constant_MATRIX_SQUARE_EXCEPTION" title="MATRIX_SQUARE_EXCEPTION ::">
                        <span class="description"></span><pre>MATRIX_SQUARE_EXCEPTION</pre>
                    </a>
                </li>            </ul>
        </li>
    </ul>
        </div>

        <div class="span8">
            <div class="element class">
                <h1>LUDecomposition</h1>
                <small style="display: block; text-align: right">                </small>
                <p class="short_description">For an m-by-n matrix A with m &gt;= n, the LU decomposition is an m-by-n
   unit lower triangular matrix L, an n-by-n upper triangular matrix U,
   and a permutation vector piv of length m so that A(piv,:) = L*U.</p>
                <div class="details">
                    <div class="long_description"><p>If m &lt; n, then L is m-by-m and U is m-by-n.</p>
<p>The LU decompostion with pivoting always exists, even if the matrix is
singular, so the constructor will never fail. The primary use of the
LU decomposition is in the solution of square systems of simultaneous
linear equations. This will fail if isNonsingular() returns false.</p>
                    </div>
                    <table class="table table-bordered">                                <tr>
                                    <th>author                                    </th>
                                    <td><p>Paul Meagher
@author Bartosz Matosiuk
@author Michael Bommarito</p>
<p>@version 1.1</p>
                                    </td>
                                </tr>                                <tr>
                                    <th>package                                    </th>
                                    <td><p>Default</p>
                                    </td>
                                </tr>                    </table>

                    <h3><i class="icon-custom icon-method"></i> Methods</h3>                        <a id="method___construct"></a>
                        <div class="element clickable methodpublic method___construct" data-toggle="collapse" data-target=".method___construct .collapse">
                            <h2>LU Decomposition constructor.</h2>
                            <pre>__construct(\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix $A)</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$A</h4>
                                                <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>Rectangular matrix</p></p>
                                            </div>                                </div>
                            </div>

                        </div>                        <a id="method_det"></a>
                        <div class="element clickable methodpublic method_det" data-toggle="collapse" data-target=".method_det .collapse">
                            <h2>Count determinants.</h2>
                            <pre>det(): array</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>array</code><p><p>d matrix deterninat</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getDoublePivot"></a>
                        <div class="element clickable methodpublic method_getDoublePivot" data-toggle="collapse" data-target=".method_getDoublePivot .collapse">
                            <h2>Alias for getPivot.</h2>
                            <pre>getDoublePivot()</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"><p>@see getPivot</p></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                </div>
                            </div>

                        </div>                        <a id="method_getL"></a>
                        <div class="element clickable methodpublic method_getL" data-toggle="collapse" data-target=".method_getL .collapse">
                            <h2>Get lower triangular factor.</h2>
                            <pre>getL(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>Lower triangular factor</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getPivot"></a>
                        <div class="element clickable methodpublic method_getPivot" data-toggle="collapse" data-target=".method_getPivot .collapse">
                            <h2>Return pivot permutation vector.</h2>
                            <pre>getPivot(): array</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>array</code><p><p>Pivot vector</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_getU"></a>
                        <div class="element clickable methodpublic method_getU" data-toggle="collapse" data-target=".method_getU .collapse">
                            <h2>Get upper triangular factor.</h2>
                            <pre>getU(): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>Upper triangular factor</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_isNonsingular"></a>
                        <div class="element clickable methodpublic method_isNonsingular" data-toggle="collapse" data-target=".method_isNonsingular .collapse">
                            <h2>Is the matrix nonsingular?</h2>
                            <pre>isNonsingular(): boolean</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>
                                                </th>
                                                <td>                                                </td>
                                            </tr>                                    </table>                                        <h3>Response</h3>
                                        <code>boolean</code><p><p>true if U, and hence A, is nonsingular</p></p>                                </div>
                            </div>

                        </div>                        <a id="method_solve"></a>
                        <div class="element clickable methodpublic method_solve" data-toggle="collapse" data-target=".method_solve .collapse">
                            <h2>Solve A*X = B.</h2>
                            <pre>solve(mixed $B): \PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</pre>
                            <div class="labels">                            </div>
                            <div class="row collapse">
                                <div class="detail-description">
                                    <div class="long_description"></div>

                                    <table class="table">                                            <tr>
                                                <th>Throws</th>
                                                <td>
                                                    <dl>                                                        <dt>\PhpOffice\PhpSpreadsheet\Calculation\Exception</dt>
                                                        <dd><p>illegalArgumentException Matrix row dimensions must agree</p></dd>                                                        <dt>\PhpOffice\PhpSpreadsheet\Calculation\Exception</dt>
                                                        <dd><p>runtimeException  Matrix is singular</p></dd>                                                    </dl>
                                                </td>
                                            </tr>                                    </table>                                        <h3>Arguments</h3>                                            <div class="subelement argument">
                                                <h4>$B</h4>
                                                <code>mixed</code><p><p>a Matrix with as many rows as A and any number of columns</p></p>
                                            </div>                                        <h3>Response</h3>
                                        <code>\PhpOffice\PhpSpreadsheet\Shared\JAMA\Matrix</code><p><p>X so that L<em>U</em>X = B(piv,:)</p></p>                                </div>
                            </div>

                        </div>                        <h3><i class="icon-custom icon-constant"></i> Constants</h3>                            <a id="constant_MATRIX_SINGULAR_EXCEPTION"> </a>
                            <div class="element clickable constant constant_MATRIX_SINGULAR_EXCEPTION" data-toggle="collapse" data-target=".constant_MATRIX_SINGULAR_EXCEPTION .collapse">
                                <h2>MATRIX_SINGULAR_EXCEPTION</h2>
                                <pre>MATRIX_SINGULAR_EXCEPTION</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>
                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>
                                    </div>
                                </div>
                            </div>                            <a id="constant_MATRIX_SQUARE_EXCEPTION"> </a>
                            <div class="element clickable constant constant_MATRIX_SQUARE_EXCEPTION" data-toggle="collapse" data-target=".constant_MATRIX_SQUARE_EXCEPTION .collapse">
                                <h2>MATRIX_SQUARE_EXCEPTION</h2>
                                <pre>MATRIX_SQUARE_EXCEPTION</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>
                                        <table class="table">                                                <tr>
                                                    <th>
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>
                                    </div>
                                </div>
                            </div>                        <h3><i class="icon-custom icon-property"></i> Properties</h3>                            <a id="property_LU"> </a>
                            <div class="element clickable propertyprivate property_LU" data-toggle="collapse" data-target=".property_LU .collapse">
                                <h2>Decomposition storage.</h2>
                                <pre>LU :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                            <a id="property_m"> </a>
                            <div class="element clickable propertyprivate property_m" data-toggle="collapse" data-target=".property_m .collapse">
                                <h2>Row dimension.</h2>
                                <pre>m :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                            <a id="property_n"> </a>
                            <div class="element clickable propertyprivate property_n" data-toggle="collapse" data-target=".property_n .collapse">
                                <h2>Column dimension.</h2>
                                <pre>n :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                            <a id="property_pivsign"> </a>
                            <div class="element clickable propertyprivate property_pivsign" data-toggle="collapse" data-target=".property_pivsign .collapse">
                                <h2>Pivot sign.</h2>
                                <pre>pivsign :integer</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>integer</code>                                    </div>
                                </div>
                            </div>                            <a id="property_piv"> </a>
                            <div class="element clickable propertyprivate property_piv" data-toggle="collapse" data-target=".property_piv .collapse">
                                <h2>Internal storage of pivot vector.</h2>
                                <pre>piv :array</pre>
                                <div class="labels">                                </div>
                                <div class="row collapse">
                                    <div class="detail-description">
                                        <div class="long_description"></div>

                                        <table class="table">                                                <tr>
                                                    <th>var
                                                    </th>
                                                    <td>                                                    </td>
                                                </tr>                                        </table>                                            <h3>Type(s)</h3>
                                            <code>array</code>                                    </div>
                                </div>
                            </div>                </div>
            </div>
            <a id="\PhpOffice\PhpSpreadsheet\Shared\JAMA\LUDecomposition"></a>
            <ul class="breadcrumb">
                <li><a href="../index.html"><i class="icon-custom icon-class"></i></a></li>
    <li><span class="divider">\</span><a href="../namespaces/PhpOffice.PhpSpreadsheet.Shared.JAMA.html">JAMA</a></li>
                <li class="active"><span class="divider">\</span><a href="../classes/PhpOffice.PhpSpreadsheet.Shared.JAMA.LUDecomposition.html">LUDecomposition</a></li>
            </ul>
        </div>
    </div>    </div>    <footer class="span12">
            Template is built using <a href="http://twitter.github.com/bootstrap/">Twitter Bootstrap 2</a> and icons provided by
            <a href="http://glyphicons.com/">Glyphicons</a>.<br/>
            Documentation is powered by <a href="http://www.phpdoc.org/">phpDocumentor</a> and<br/>
            generated onFri, 14 Feb 2020 19:36:49 +0000.<br/>
    </footer></body>
</html>
